package org.jboss.soa.qa.test;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.xml.namespace.QName;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.SOAPBodyElement;
import javax.xml.soap.SOAPConstants;
import javax.xml.soap.SOAPMessage;

import java.io.IOException;
import java.io.OutputStream;

public class SoapMultipartCheckerServlet extends HttpServlet {

	@Override
	protected void service(final HttpServletRequest req, final HttpServletResponse resp) throws ServletException, IOException {
		final String requestedContentType = req.getHeader("Content-Type");
		System.out.println("Requested content type : " + requestedContentType);

		try {
			replyRequestedContentTypeInResponse(requestedContentType, resp);
		} catch (final Exception e) {
			throw new ServletException(e.getMessage(), e);
		}
	}

	private void replyRequestedContentTypeInResponse(final String requestedContentType, final HttpServletResponse resp) throws Exception {
		final MessageFactory msgFactory = MessageFactory.newInstance(SOAPConstants.SOAP_1_2_PROTOCOL);
		final SOAPMessage msg = msgFactory.createMessage();
		final SOAPBodyElement bodyElement = msg.getSOAPBody().addBodyElement(
				new QName("urn:not-important:1.0", "requestedContentType"));

		bodyElement.addTextNode(requestedContentType);

		resp.setStatus(HttpServletResponse.SC_OK);
		resp.setHeader("Content-Type", "application/soap+xml; charset=utf-8");
		final OutputStream os = resp.getOutputStream();
		msg.writeTo(os);
		os.close();
	}
}
